import { AbstractProperty, DataTypeOfProperty } from "../../properties/abstract-property";
import { PropertyTemplate } from "../../properties/factory/property-template";
import { GroupOfProperties } from "../../properties/group-of-properties";
import { ListIndex } from "../../properties/factory/list-index";
import { GroupOfPropertiesImpl } from "../../properties/group-of-properties-impl";
import { SiblingAccess } from "../../provider/list-provider/sibling-access";
import { ValidationResult } from "../../validators/validation-result";
declare type GroupData<T extends {
    [id: string]: AbstractProperty<unknown>;
}> = {
    [K in keyof T]: DataTypeOfProperty<T[K]>;
};
export declare class GroupOfPropertiesBuilder {
    private readonly propertyGroup;
    constructor(propertyGroup: <T extends {
        [id: string]: AbstractProperty<unknown>;
    }, D>(id: string, properties: T, exportFcn: (props: T) => D | null, importFcn: (props: T, data: D | null) => void) => GroupOfPropertiesImpl<T, D>);
    template<T extends {
        [id: string]: AbstractProperty<unknown>;
    }>(propertiesOfGroup: (idFcn: (id: string) => string, index?: ListIndex, siblingAccess?: SiblingAccess<GroupOfProperties<T, GroupData<T>>, unknown>) => T): PropertyTemplate<GroupOfProperties<T, GroupData<T>>, GroupData<T>>;
    of<T extends {
        [id: string]: AbstractProperty<unknown>;
    }>(id: string, propertiesOfGroup: T): GroupOfProperties<T, {
        [K in keyof T]: DataTypeOfProperty<T[K]>;
    }>;
    private processOptional;
    bindValidator<T extends {
        [id: string]: AbstractProperty<unknown>;
    }, D>(group: GroupOfProperties<T, D>, validator: (group: T) => ValidationResult | Promise<ValidationResult>): void;
}
export {};
