import { AbstractProperty } from "../properties/abstract-property";
import { ValidationResult } from "../validators/validation-result";
import { ValidatorInstance } from "./validation/validator-instance-impl";
export interface RuleEngineUpdateHandler<D> {
    needsAnUpdate(mightHaveChanged: AbstractProperty<D>): void;
    updateValue(property: AbstractProperty<D>): Promise<void>;
    invalidateValidationResults(validators: readonly ValidatorInstance<readonly AbstractProperty<unknown>[]>[]): void;
    validate(validators: readonly ValidatorInstance<readonly AbstractProperty<unknown>[]>[]): Promise<ValidationResult>[];
}
