const defaultExportFcn = (props) => Object.keys(props).reduce((res, cur) => {
    res[cur] = props[cur].exportData();
    return res;
}, {});
const defaultImportFcn = (props, data) => data instanceof Object && Object.keys(props).forEach(key => {
    props[key].importData(data[key]);
});
export class GroupOfPropertiesBuilder {
    constructor(propertyGroup) {
        this.propertyGroup = propertyGroup;
    }
    template(propertiesOfGroup, optional) {
        const processOptional = this.processOptional(optional);
        return (id, index, siblingAccess) => this.propertyGroup(id, propertiesOfGroup(suffix => `${id}_${suffix}`, index, siblingAccess), processOptional.exportFcn, processOptional.importFcn);
    }
    of(id, propertiesOfGroup, optional) {
        const processOptional = this.processOptional(optional);
        return this.propertyGroup(id, propertiesOfGroup, processOptional.exportFcn, processOptional.importFcn);
    }
    processOptional(optional) {
        var _a, _b;
        return {
            exportFcn: (_a = optional === null || optional === void 0 ? void 0 : optional.exportFcn) !== null && _a !== void 0 ? _a : defaultExportFcn,
            importFcn: (_b = optional === null || optional === void 0 ? void 0 : optional.importFcn) !== null && _b !== void 0 ? _b : defaultImportFcn
        };
    }
    bindValidator(group, validator) {
        const instance = {
            getValidatedProperties: () => group.propertiesAsList,
            validate: () => validator(group.properties)
        };
        group.addValidator(instance);
    }
}
