import { AbstractProperty } from "../properties/abstract-property";
import { RuleEngineUpdateHandler } from "./rule-engine-update-handler-impl";
import { Snapshot } from "./snapshot/snapshot";
import { BuilderOptions } from "./builder/builder-options";
import { Builder } from "./builder/builder";
import { ValidationResult } from "../validators/validation-result";
import { ValidatorInstance } from "./validation/validator-instance-impl";
export declare class RuleEngine implements RuleEngineUpdateHandler<unknown> {
    private readonly propertyMap;
    private readonly dependencyGraph;
    private readonly validations;
    private readonly dataLinks;
    private readonly snapshots;
    private propertiesThatRequireAnEagerUpdate;
    private get properties();
    builder(options: BuilderOptions): Builder;
    takeSnapShot(key?: string): Snapshot;
    restoreSnapShot(key?: string): void;
    linkPropertyData<D>(propertyA: AbstractProperty<D>, propertyB: AbstractProperty<D>): void;
    unlinkPropertyData<D>(propertyA: AbstractProperty<D>, propertyB: AbstractProperty<D>): void;
    private createDataLinkKey;
    transferData<D>(fromProperty: AbstractProperty<D>, toProperty: AbstractProperty<D>): void;
    needsAnUpdate(mightHaveChanged: AbstractProperty<unknown>): void;
    updateValue(property: AbstractProperty<unknown>): Promise<void>;
    private hasBeenUpdated;
    invalidateValidationResults(validators: readonly ValidatorInstance<readonly AbstractProperty<unknown>[]>[]): void;
    validate(validators: readonly ValidatorInstance<readonly AbstractProperty<unknown>[]>[]): Promise<ValidationResult>[];
    private getValidationProcess;
}
