import { AbstractPropertyImpl } from "./abstract-property-impl";
import { ListOfProperties } from "./list-of-properties";
import { AbstractProperty } from "./abstract-property";
import { RuleEngineUpdateHandler } from "../engine/rule-engine-update-handler-impl";
import { ListProvider } from "../provider/list-provider/list-provider";
import { OwnerRelation } from "../dependency-graph/dependency-graph";
export declare class ListOfPropertiesImpl<T extends AbstractProperty<D>, D> extends AbstractPropertyImpl<(D | null)[]> implements ListOfProperties<T, D> {
    readonly id: string;
    private readonly listProvider;
    private readonly selectedIndices;
    private readonly isMultiSelect;
    private readonly ownerRelation;
    get length(): number;
    get list(): T[];
    constructor(id: string, listProvider: ListProvider<T, D>, selectedIndices: number[], isMultiSelect: boolean, updateHandler: RuleEngineUpdateHandler<(D | null)[]>, ownerRelation: OwnerRelation);
    protected internallySyncUpdate(): void;
    protected internallyAsyncUpdate<V>(): {
        asyncPromise: Promise<V>;
        resolve: (value: V) => void;
    };
    protected getSpecialisedValidationResult(): never[];
    getProperty(index: number): T | undefined;
    addProperty(property?: T, atIndex?: number, dontNotify?: boolean): T;
    addProperties(properties: number | T[], atIndex?: number): T[];
    addPropertyData(data: (D | null)[], atIndex?: number): T[];
    swapProperties(indexA: number, indexB: number): void;
    moveProperty(fromIndex: number, toIndex: number): void;
    removePropertyAtIndex(index: number): T | undefined;
    removeProperty(property: T): boolean;
    selectPropertyAtIndex(index: number): void;
    selectProperty(property: T): void;
    isPropertySelectedAtIndex(index: number): boolean;
    isPropertySelected(property: T): boolean;
    getSelectedIndices(): number[];
    getSelectedProperties(): {
        property: T;
        index: number;
    }[];
    unselectPropertyAtIndex(index: number): void;
    unselectProperty(property: T): void;
    unselectAll(): void;
    isValid(): boolean;
    isProcessing(): boolean;
    isReadOnly(): boolean;
    isAsynchronous(): boolean;
    exportData(): (D | null)[];
    importData(data: (D | null)[]): void;
    compareData(a: (D | null)[], b: (D | null)[]): boolean;
}
