import { AbstractProperty } from "./abstract-property";
import { AttributeId } from "../attributes/attribute-id";
export interface PropertyScalar<T> extends AbstractProperty<T> {
    setToInitialValue(): void;
    getInitialValue(): T | null;
    getDisplayValue(): string;
    setDisplayValue(value: string | null): void;
    awaitDisplayValue(): Promise<string>;
    getNonNullValue(): T;
    getValue(): T | null;
    setValue(value: T | null): void;
    awaitValue(): Promise<T | null>;
    get<A>(id: AttributeId<A>): A | undefined;
    isRequired(): boolean;
    isVisible(): boolean;
    isEmpty(): boolean;
    getLabel(): string;
    getInfoText(): string;
    getPlaceholder(): string;
}
